//     , 
// ,   .
#include <iostream.h>
#define TRUE 1
#define FALSE 0
#define Node 20 //    .
typedef int Boolean;
typedef struct L *Lref; // :    .
typedef struct T *Tref; // :    .

//   .
typedef struct L 
{ 
  int Key; //  .
  int Count; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
};

//   .
typedef struct T 
{ 
  Lref Id; 
  Tref Next; 
};

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //    
               //     .
    int  X[20]; //  .
    void SearchGraph (int, Lref *);
    Lref Search(int);
  public:
    Spisok() {//   .
              Head = Tail =  new (L); }
    Lref GetHead() { return Head; }
    Lref GetTail() { return Tail; }
    void MakeGraph ();
    void PrintGraph ();
    void AddGraph(int, int);
    void DeleteGraph(int, int);
    void Clique (int, int);
    void X1 (Lref t) {X[1] = t->Key;};
};

void main ()
{
  Spisok A;
  Lref t; //    
          //    .
  Lref t1;
  int n=0;

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //     .
  t = A.GetHead();
  while (t!=A.GetTail())
    { n++; t = (*t).Next; }
  // ------------------------------------ 
  //     Head.
  for (int i=3;i<=n;i++)
  {
    //i -     (i<=3).
    cout << "    " << i << endl;
    t = A.GetHead();
    while (t!=A.GetTail())
    {
       //.
       t1 = A.GetHead();
       while (t1!=A.GetTail())
       { t1->Flag = TRUE; t1 = t1->Next;  }
       A.X1(t); t->Flag = FALSE;
       //   i , ""   t.
       A.Clique (2,i); t = t->Next;
    }
  }
} 

Lref Spisok::Search (int w)
//      
// w.   ,    NULL .
{
  Lref h = Head;
  (*Tail).Key = w; // " ".
  while ((*h).Key!=w) h = (*h).Next;
  if (h==Tail) //        w.
    h = NULL;
  return h;
} 

void Spisok::AddGraph (int x,int y)
//  (x,y) (   !)  
//,    Head.
{
  Lref p,q;    // .
  Tref t,r;    // .
  Boolean Res; //     .

  //,      (x,y)? 
  SearchGraph (x,&p); SearchGraph (y,&q);
  r = (*p).Trail; Res = FALSE;
  while ((r!=NULL)&&(!Res)) 
    if ((*r).Id==q) Res = TRUE; else r = (*r).Next;
  if (!Res)
  { //  ,     .
    t = new (T); (*t).Id = q; (*t).Next = (*p).Trail; 
    (*p).Trail = t; (*q).Count++;
  }
} 

void Spisok::DeleteGraph (int x,int y)
//   Head   
//,   
//    (x,y).
{
  Lref p,q;    // .
  Tref t,r;    // .
  Boolean Res; //     .

  //,      (x,y)?
  p=Search (x); q= Search (y);
  if ((p!=NULL)&&(q!=NULL))
  { // x  y   .
    r = (*p).Trail; Res = FALSE; 
    while ((r!=NULL)&&(!Res)) 
      if ((*r).Id==q) Res = TRUE; 
      else r = (*r).Next; 
   if (Res) //  ,   .
   if (r==(*p).Trail)
     { (*p).Trail = (*(*p).Trail).Next; delete r; (*q).Count--; } 
   else 
    {
      t = (*p).Trail; 
      while ((*t).Next!=r) t = (*t).Next;
      (*t).Next = (*(*t).Next).Next; delete r; (*q).Count--; }
    }
} 

void Spisok::SearchGraph (int w, Lref *h)
//      
//  w  ,      Head. 
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (L); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
     cout<<"   : "; cin>>y;
     //,      (x,y)?
     SearchGraph (x, &p); SearchGraph (y,&q);
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL)&&(!Res)) 
       if ((*r).Id==q) Res = TRUE; 
       else r = (*r).Next; 
     if (!Res) //  ,     .
      { t = new (T); (*t).Id = q; 
        (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
     cout<< (*p).Key << "("; q = (*p).Trail; 
     while (q!=NULL) 
      { cout<<(*(*q).Id).Key; q = (*q).Next; } 
     cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::Clique (int k, int m)
//  ,  m ,  ,
//     Head,
//k -     .
{
  Tref r,r1;   // .
  Lref p,q;    // .
  Lref t;      //  k-   .
  int v;       // -      .
  Boolean Res; // .
  Boolean Res1;//  .
  int i;       // .

  SearchGraph (X[k-1], &t);
  r = t->Trail;
  while ( r != NULL )
  {
    v = r->Id->Key;
    //,    v   X[1],X[2],...,X[k-1].
    Res = TRUE;
    for (i=1;i<=k-1;i++)
    {
      //C     (X[i],v)?
      SearchGraph (v, &p);
      SearchGraph (X[i], &q);
      r1 = p->Trail;
      Res1 = FALSE;
      while  (r1 != NULL && !Res1)
       if ( r1->Id==q ) Res1 = TRUE;
       else  r1 = r1->Next;
      Res = (Res && Res1);
    }
    if (!Res) r->Id->Flag = FALSE;
    // -------------------------- 
    if  (k==m && Res)
      //     m, 
      // X[1],X[2],...,X[k]  .
      {
        //    .
        for (i=1;i<=k-1;i++) cout << X[i] << " ";
        cout << v << endl;
      }
    else  
      if ( r->Id->Flag )
      {
        X[k] = r->Id->Key;
        r->Id->Flag = FALSE;
        Clique (k+1,m);
        r->Id->Flag = TRUE;
      }
    r = r->Next;
  }
}
